/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "MoteurImage.hpp"

GestionnaireImage *GestionnaireImage::objetSingleton = 0;

GestionnaireImage::GestionnaireImage()
{
	
}

GestionnaireImage::~GestionnaireImage()
{
	for (int i=0; i < listeImages.size(); i++)
	{
		delete listeImages[i];
	}
}

GestionnaireImage *GestionnaireImage::recupereInstance()
{
	if (!objetSingleton)
		objetSingleton = new GestionnaireImage();
	
	return objetSingleton;
}

sf::Image *GestionnaireImage::recupereImage(std::string pCheminImage)
{
	int resultatRechercheImage = rechercheImage(pCheminImage);
	if (resultatRechercheImage == -1)
	{
		chargeImage(pCheminImage);
		return listeImages.back();
	}
	else
		return listeImages[resultatRechercheImage];
}

void GestionnaireImage::chargeImage(std::string pCheminImage)
{	
	sf::Image *imageChargee = new sf::Image();
	imageChargee->LoadFromFile(pCheminImage);
	imageChargee->SetSmooth(false);
	
	listeNomsImages.push_back( pCheminImage );
	listeImages.push_back( imageChargee );
}

int GestionnaireImage::rechercheImage(std::string pCheminImage)
{
	std::vector<std::string>::iterator it;
	it = std::find(listeNomsImages.begin(), listeNomsImages.end(), pCheminImage);
	
	if (it != listeNomsImages.end())
	{
		int ixImage = std::distance(listeNomsImages.begin(), it);
		return ixImage;
	}
	
	return -1;
}
